<?php
/*
'--------------------------------------------------------
'软件名称：MVSO
'开发作者：GMeier
*官方网站：http://www.gmeier.top/
*bug反馈交流：524500448
'--------------------------------------------------------
*/
declare (strict_types = 1);

namespace app\admin\controller;

use app\BaseController;
use think\facade\Session;
use think\facade\View;
use think\facade\Config;
use think\Request;

class Index extends BaseController
{
	// 首页
    public function index()
    {
		return View('index');
	}
	
	// welcome页面
	public function welcome()
	{
		$php = ['e'	=>	$_SERVER['SERVER_SOFTWARE']];
		return View::fetch('welcome',['mvso_php'	=>	$php]);
	}
	
	// setting页面
	public function setting(Request $request)
	{
		// POST验证
		if($request->isPost()){
			$data = Config::get('config');
			
			$data['webtitle'] = $request->param('webtitle','','trim');
			$data['keywords'] = $request->param('keywords','','trim');
			$data['description'] = $request->param('description','','trim');
			$data['view'] = $request->param('view','','trim');
			$data['link'] = $request->param('link','','trim');
			$data['cnzz'] = $request->param('cnzz','','trim');
			$data['copyright'] = $request->param('copyright','','trim');
			$data['author'] = $request->param('author','','trim');
			$data['url'] = $request->param('url','','trim');
			
			return $this->fwrite($data);
		}else{
			return View();
		}
	}
	
	// 解析页面
	public function jx(Request $request)
	{
		if($request->isPost()){
			$data = Config::get('config');
			
			$data['jx'] = $request->param('jx','','trim');
			return $this->fwrite($data);
		}else{
			return View();
		}
	}
	
	// 资源页面
	public function zy(Request $request)
	{
		if($request->isPost()){
			$data = Config::get('config');
			
			$data['zy'] = $request->param('zy','','trim');
			return $this->fwrite($data);
		}else{
			return View();
		}
	}
	
	// 作者
	public function author()
	{
		return view();
	}
	
	// 在线更新
	public function update()
	{
		$url = json_decode(file_get_contents('http://www.gmeier.top/api.php'),true);
		View::assign('mvso_update',$url);
		return View();
	}
	
	// 修改密码
	public function repass(Request $request)
	{
		if($request->isPost()){
			$data = Config::get('config');
			
			$password = $request->param('password','','trim');
			if($password == $data['password']){
				$data['password'] = $request->param('newpass','','trim');
				return $this->fwrite($data);
			}else{
				return json(['status' => 'fail','msg' => '保存失败']);
			}
		}else{
			return View();
		}
	}
	
	// 写入配置
	private function fwrite($data)
	{
		$path = './config/config.php';
		$fps = fopen($path,'w+');
		fwrite($fps,var_export($data,true));
		fclose($fps);
		file_put_contents($path,str_replace('array (','[',file_get_contents($path)));
		file_put_contents($path,str_replace(')',']',file_get_contents($path)));
		$arr = explode("\r\n",file_get_contents($path));
		$arr[0] = "<?php\n// 这是应用配置文件\n\nreturn\n$arr[0];";
		$txt = implode("\r\n",$arr);
		if(file_put_contents($path, $txt)){
			return json(['status' => 'success','msg' => '保存成功']);
		}else{
			return json(['status' => 'fail','msg' => '保存失败']);
		}
	}
	
	// 获取/config/config.php文件的第一行
	private function getLine($file, $line, $length = 4096)
	{
		$returnTxt = null; // 初始化返回
		$i = 1; //行数
		$handle = @fopen($file, "r");
		if ($handle) {
			while (!feof($handle)) {
				$buffer = fgets($handle, $length);
				if($line == $i) $returnTxt = $buffer;
				$i++;
			}
			fclose($handle);
		}
		return $returnTxt;
	}
}
