<?php
/*
'--------------------------------------------------------
'软件名称：MVSO
'开发作者：GMeier
*官方网站：http://www.gmeier.top/
*bug反馈交流：524500448
'--------------------------------------------------------
*/
declare (strict_types = 1);

namespace app\admin\controller;

use think\facade\Session;
use think\facade\View;
use think\captcha\facade\Captcha;
use think\facade\Config;
use think\Request;

class Login
{
	// 登陆
    public function login(Request $request)
    {
		if($request->isPost()){
			$captcha = $request->param('captcha','','trim');
			$username = $request->param('username','','trim');
			$password = $request->param('password','','trim');
			if(($username != Config::get('config.username'))){
				return json(['status' => 'fail','msg' => '用户名不存在']);
			};
			if(!captcha_check($captcha)){
				return json(['status' => 'fail','msg' => '验证码错误']);
			};
			if(($password != Config::get('config.password'))){
				return json(['status' => 'fail','msg' => '密码错误']);
			};
			Session::set('username',$username);
			return json(['status' => 'success','msg' => '登陆成功']);
		}else{
			return View::fetch('login');
		}
	}
	
	// 验证码生成
	public function captcha()
	{
		return Captcha::create();
	}
	
	// 退出登陆
	public function logout()
	{
		// 清理Session
		Session('username',null);
		return json(['status' => 'success','msg' => '退出成功']);
	}
}
