<?php
/*
'--------------------------------------------------------
'软件名称：MVSO
'开发作者：GMeier
*官方网站：http://www.gmeier.top/
*bug反馈交流：524500448
'--------------------------------------------------------
*/
declare (strict_types = 1);

namespace app\index\controller;

use app\BaseController;
use app\Rule;
use think\facade\View;
use think\facade\Config;
use think\Request;

class Index extends BaseController
{
	// 首页
    public function Index(Request $Request,$list = 'index',$page = 1)
    {
		error_reporting(0);
		$list = $this->request->param('list')?$this->request->param('list'):'index';
		$page = $this->request->param('page')?$this->request->param('page'):1;
		$li = new Rule();
		if($list == 'index'){
			$data = $li->getlist('dianying',1);
		}else{
			$data = $li->getlist($list,$page);
		}
		switch($list){
			case 'index':$listtitle = '首页';break;
			case 'dianying':$listtitle = '电影';break;
			case 'dianshi':$listtitle = '电视剧';break;
			case 'zongyi':$listtitle = '综艺';break;
			case 'dongman':$listtitle = '动漫';break;
			default:$listtitle = '页面错误';break;
		}
		View::assign([
			'mvso_list'			=>	$data,
			'mvso_listtitle'	=>	$listtitle,
			'mvso_lunbo'		=>	$li->lunbo(),
			'mvso_listtype'		=>	$list,
			'mvso_listpage'		=>	$page,
		]);
		return View::fetch($this->view().'@Index',$this->mvso_data());
    }
	
	// 搜索
	public function So(Request $request,$wd,$type)
	{
		error_reporting(0);
		$wd = $this->request->param('wd');
		$type = $this->request->param('type');
		if($type == '360')
		{
			$li = new Rule();
			if($li->so($wd)['status'] == '400'){
				header('Location: /index/so/wd/'.$wd.'/type/0');
			}
			View::assign('mvso_solist',$li->so($wd));
			return View::fetch($this->view().'@So',$this->mvso_data());
		}else{
			$zy = $this->fenjie('config.zy')[$type][1];
			$zy_name = $this->fenjie('config.zy')[$type][0];
			$url = file_get_contents($zy.'?wd='.$wd);
			$url = json_decode(json_encode(simplexml_load_string($url, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
			if(!array_key_exists('video',$url['list'])){
				$data[0]['list']['video']['name'] = '没有数据';
				$data[0]['list']['video']['pic'] = '/player/logo.png';
				$data[0]['list']['video']['id'] = '';
			}else if(array_key_exists('0',$url['list']['video'])){
				for($i=0;$i<count($url['list']['video']);$i++){
					$list = file_get_contents($zy.'?ac=videolist&ids='.$url['list']['video'][$i]['id']);
					$list = json_decode(json_encode(simplexml_load_string($list, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
					$data[$i] = $list;
				}
			}else{
				for($i=0;$i<1;$i++){
					$list = file_get_contents($zy.'?ac=videolist&ids='.$url['list']['video']['id']);
					$list = json_decode(json_encode(simplexml_load_string($list, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
					$data[$i] = $list;
				}
			}
			View::assign([
				'mvso_zylist'	=>	$data,
				'mvso_zyname'	=>	$zy_name,
			]);
			return View::fetch($this->view().'@So',$this->mvso_data());
		}
	}
	
	// 播放器
	public function Play(Request $request,$id,$type,$number)
	{
		error_reporting(0);
		$id = $this->request->param('id');
		$type = $this->request->param('type');
		$number = $this->request->param('number');
		$url = 'http://www.360kan.com/'.$type.'/'.$id.'.html';
		if($type == 'm'||$type == 'tv'||$type == 'ct'||$type == 'va')
		{
			$li = new Rule();
			View::assign([
				'mvso_playlist'	=>	$li->getdata($url),
			]);
			return View::fetch($this->view().'@Play',$this->mvso_data());
		}else{
			// 获取资源站地址
			$zy = $this->fenjie('config.zy')[$type][1];
			// 获取m3u8地址
			$zy_no = $this->fenjie('config.zy')[$type][2];
			// 获取资源内容
			$list = file_get_contents($zy.'?ac=videolist&ids='.$id);
			// xml转json
			$list = json_decode(json_encode(simplexml_load_string($list, 'SimpleXMLElement', LIBXML_NOCDATA)), true);
			if($zy_no == ''){
				$m3u8 = $list['list']['video']['dl']['dd'];
			}else{
				$m3u8 = $list['list']['video']['dl']['dd'][$zy_no];
			}
			$m3u8 = explode("#",$m3u8);
			for($i=0;$i<count($m3u8);$i++){
				$m3u8[$i] = explode("$",$m3u8[$i]);
			}
			View::assign([
				'mvso_m3u8list'	=>	$m3u8,
				'mvso_m3u8info'	=>	$list['list']['video'],
			]);
			return View::fetch($this->view().'@Play',$this->mvso_data());
		}
	}
	
	// View
	private function view()
	{
		return Config::get('config.view');
	}
	
	// 数据
	private function mvso_data()
	{
		return [
			'mvso_config'	=>	Config::get('config'),
			'mvso_link'		=>	$this->fenjie('config.link'),
			'mvso_jx'		=>	$this->fenjie('config.jx'),
			'mvso_zy'		=>	$this->fenjie('config.zy'),
		];
	}
	
	// 分解
	private function fenjie($res)
	{
		$data = Config::get($res);
		$data = explode("\n",$data);
		for($i=0;$i<count($data);$i++){
			$data[$i] = explode(",",$data[$i]);
		}
		return $data;
	}
}
